// Java class org.ethereum.geth.Address is a proxy for talking to a Go program.
//   gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
//
// File is generated by gobind. Do not edit.
package org.ethereum.geth;

import go.Seq;

/**
 * Address represents the 20 byte address of an Ethereum account.
 */
public final class Address implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewAddressFromBytes converts a slice of bytes to a hash value.
	 */
	public Address(byte[] binary) {
		this.refnum = __NewAddressFromBytes(binary);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewAddressFromBytes(byte[] binary);
	
	/**
	 * NewAddressFromHex converts a hex string to a address value.
	 */
	public Address(String hex) {
		this.refnum = __NewAddressFromHex(hex);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewAddressFromHex(String hex);
	
	Address(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * GetBytes retrieves the byte representation of the address.
	 */
	public native byte[] getBytes();
	/**
	 * GetHex retrieves the hex string representation of the address.
	 */
	public native String getHex();
	/**
	 * SetBytes sets the specified slice of bytes as the address value.
	 */
	public native void setBytes(byte[] address) throws Exception;
	/**
	 * SetHex sets the specified hex string as the address value.
	 */
	public native void setHex(String address) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof Address)) {
		    return false;
		}
		Address that = (Address)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("Address").append("{");
		return b.append("}").toString();
	}
}

