// Java class org.ethereum.geth.Header is a proxy for talking to a Go program.
//   gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
//
// File is generated by gobind. Do not edit.
package org.ethereum.geth;

import go.Seq;

/**
 * Header represents a block header in the Ethereum blockchain.
 */
public final class Header implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewHeaderFromJSON parses a header from a JSON data dump.
	 */
	public Header(String data) {
		this.refnum = __NewHeaderFromJSON(data);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewHeaderFromJSON(String data);
	
	/**
	 * NewHeaderFromRLP parses a header from an RLP data dump.
	 */
	public Header(byte[] data) {
		this.refnum = __NewHeaderFromRLP(data);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewHeaderFromRLP(byte[] data);
	
	Header(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * EncodeJSON encodes a header into a JSON data dump.
	 */
	public native String encodeJSON() throws Exception;
	/**
	 * EncodeRLP encodes a header into an RLP data dump.
	 */
	public native byte[] encodeRLP() throws Exception;
	public native Bloom getBloom();
	public native Address getCoinbase();
	public native BigInt getDifficulty();
	public native byte[] getExtra();
	public native long getGasLimit();
	public native long getGasUsed();
	public native Hash getHash();
	public native Hash getMixDigest();
	public native Nonce getNonce();
	public native long getNumber();
	public native Hash getParentHash();
	public native Hash getReceiptHash();
	public native Hash getRoot();
	public native long getTime();
	public native Hash getTxHash();
	public native Hash getUncleHash();
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof Header)) {
		    return false;
		}
		Header that = (Header)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("Header").append("{");
		return b.append("}").toString();
	}
}

