// Java class org.ethereum.geth.NodeConfig is a proxy for talking to a Go program.
//   gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
//
// File is generated by gobind. Do not edit.
package org.ethereum.geth;

import go.Seq;

/**
 * NodeConfig represents the collection of configuration values to fine tune the Geth
node embedded into a mobile process. The available values are a subset of the
entire API provided by go-ethereum to reduce the maintenance surface and dev
complexity.
 */
public final class NodeConfig implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewNodeConfig creates a new node option set, initialized to the default values.
	 */
	public NodeConfig() {
		this.refnum = __NewNodeConfig();
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewNodeConfig();
	
	NodeConfig(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * Bootstrap nodes used to establish connectivity with the rest of the network.
	 */
	public final native Enodes getBootstrapNodes();
	/**
	 * Bootstrap nodes used to establish connectivity with the rest of the network.
	 */
	public final native void setBootstrapNodes(Enodes v);
	
	/**
	 * MaxPeers is the maximum number of peers that can be connected. If this is
	set to zero, then only the configured static and trusted peers can connect.
	 */
	public final native long getMaxPeers();
	/**
	 * MaxPeers is the maximum number of peers that can be connected. If this is
	set to zero, then only the configured static and trusted peers can connect.
	 */
	public final native void setMaxPeers(long v);
	
	/**
	 * EthereumEnabled specifies whether the node should run the Ethereum protocol.
	 */
	public final native boolean getEthereumEnabled();
	/**
	 * EthereumEnabled specifies whether the node should run the Ethereum protocol.
	 */
	public final native void setEthereumEnabled(boolean v);
	
	/**
	 * EthereumNetworkID is the network identifier used by the Ethereum protocol to
	decide if remote peers should be accepted or not.
	 */
	public final native long getEthereumNetworkID();
	/**
	 * EthereumNetworkID is the network identifier used by the Ethereum protocol to
	decide if remote peers should be accepted or not.
	 */
	public final native void setEthereumNetworkID(long v);
	
	/**
	 * EthereumGenesis is the genesis JSON to use to seed the blockchain with. An
	empty genesis state is equivalent to using the mainnet&#39;s state.
	 */
	public final native String getEthereumGenesis();
	/**
	 * EthereumGenesis is the genesis JSON to use to seed the blockchain with. An
	empty genesis state is equivalent to using the mainnet&#39;s state.
	 */
	public final native void setEthereumGenesis(String v);
	
	/**
	 * EthereumDatabaseCache is the system memory in MB to allocate for database caching.
	A minimum of 16MB is always reserved.
	 */
	public final native long getEthereumDatabaseCache();
	/**
	 * EthereumDatabaseCache is the system memory in MB to allocate for database caching.
	A minimum of 16MB is always reserved.
	 */
	public final native void setEthereumDatabaseCache(long v);
	
	/**
	 * EthereumNetStats is a netstats connection string to use to report various
	chain, transaction and node stats to a monitoring server.
	
	It has the form &#34;nodename:secret@host:port&#34;
	 */
	public final native String getEthereumNetStats();
	/**
	 * EthereumNetStats is a netstats connection string to use to report various
	chain, transaction and node stats to a monitoring server.
	
	It has the form &#34;nodename:secret@host:port&#34;
	 */
	public final native void setEthereumNetStats(String v);
	
	/**
	 * WhisperEnabled specifies whether the node should run the Whisper protocol.
	 */
	public final native boolean getWhisperEnabled();
	/**
	 * WhisperEnabled specifies whether the node should run the Whisper protocol.
	 */
	public final native void setWhisperEnabled(boolean v);
	
	/**
	 * Listening address of pprof server.
	 */
	public final native String getPprofAddress();
	/**
	 * Listening address of pprof server.
	 */
	public final native void setPprofAddress(String v);
	
	/**
	 * Sync mode for the node (eth/downloader/modes.go)
	This has to be integer since Enum exports to Java are not supported by &#34;gomobile&#34;
	See getSyncMode(syncMode int)
	 */
	public final native long getSyncMode();
	/**
	 * Sync mode for the node (eth/downloader/modes.go)
	This has to be integer since Enum exports to Java are not supported by &#34;gomobile&#34;
	See getSyncMode(syncMode int)
	 */
	public final native void setSyncMode(long v);
	
	/**
	 * UseLightweightKDF lowers the memory and CPU requirements of the key store
	scrypt KDF at the expense of security.
	See https://geth.ethereum.org/doc/Mobile_Account-management for reference
	 */
	public final native boolean getUseLightweightKDF();
	/**
	 * UseLightweightKDF lowers the memory and CPU requirements of the key store
	scrypt KDF at the expense of security.
	See https://geth.ethereum.org/doc/Mobile_Account-management for reference
	 */
	public final native void setUseLightweightKDF(boolean v);
	
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof NodeConfig)) {
		    return false;
		}
		NodeConfig that = (NodeConfig)o;
		Enodes thisBootstrapNodes = getBootstrapNodes();
		Enodes thatBootstrapNodes = that.getBootstrapNodes();
		if (thisBootstrapNodes == null) {
			if (thatBootstrapNodes != null) {
			    return false;
			}
		} else if (!thisBootstrapNodes.equals(thatBootstrapNodes)) {
		    return false;
		}
		long thisMaxPeers = getMaxPeers();
		long thatMaxPeers = that.getMaxPeers();
		if (thisMaxPeers != thatMaxPeers) {
		    return false;
		}
		boolean thisEthereumEnabled = getEthereumEnabled();
		boolean thatEthereumEnabled = that.getEthereumEnabled();
		if (thisEthereumEnabled != thatEthereumEnabled) {
		    return false;
		}
		long thisEthereumNetworkID = getEthereumNetworkID();
		long thatEthereumNetworkID = that.getEthereumNetworkID();
		if (thisEthereumNetworkID != thatEthereumNetworkID) {
		    return false;
		}
		String thisEthereumGenesis = getEthereumGenesis();
		String thatEthereumGenesis = that.getEthereumGenesis();
		if (thisEthereumGenesis == null) {
			if (thatEthereumGenesis != null) {
			    return false;
			}
		} else if (!thisEthereumGenesis.equals(thatEthereumGenesis)) {
		    return false;
		}
		long thisEthereumDatabaseCache = getEthereumDatabaseCache();
		long thatEthereumDatabaseCache = that.getEthereumDatabaseCache();
		if (thisEthereumDatabaseCache != thatEthereumDatabaseCache) {
		    return false;
		}
		String thisEthereumNetStats = getEthereumNetStats();
		String thatEthereumNetStats = that.getEthereumNetStats();
		if (thisEthereumNetStats == null) {
			if (thatEthereumNetStats != null) {
			    return false;
			}
		} else if (!thisEthereumNetStats.equals(thatEthereumNetStats)) {
		    return false;
		}
		boolean thisWhisperEnabled = getWhisperEnabled();
		boolean thatWhisperEnabled = that.getWhisperEnabled();
		if (thisWhisperEnabled != thatWhisperEnabled) {
		    return false;
		}
		String thisPprofAddress = getPprofAddress();
		String thatPprofAddress = that.getPprofAddress();
		if (thisPprofAddress == null) {
			if (thatPprofAddress != null) {
			    return false;
			}
		} else if (!thisPprofAddress.equals(thatPprofAddress)) {
		    return false;
		}
		long thisSyncMode = getSyncMode();
		long thatSyncMode = that.getSyncMode();
		if (thisSyncMode != thatSyncMode) {
		    return false;
		}
		boolean thisUseLightweightKDF = getUseLightweightKDF();
		boolean thatUseLightweightKDF = that.getUseLightweightKDF();
		if (thisUseLightweightKDF != thatUseLightweightKDF) {
		    return false;
		}
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {getBootstrapNodes(), getMaxPeers(), getEthereumEnabled(), getEthereumNetworkID(), getEthereumGenesis(), getEthereumDatabaseCache(), getEthereumNetStats(), getWhisperEnabled(), getPprofAddress(), getSyncMode(), getUseLightweightKDF()});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("NodeConfig").append("{");
		b.append("BootstrapNodes:").append(getBootstrapNodes()).append(",");
		b.append("MaxPeers:").append(getMaxPeers()).append(",");
		b.append("EthereumEnabled:").append(getEthereumEnabled()).append(",");
		b.append("EthereumNetworkID:").append(getEthereumNetworkID()).append(",");
		b.append("EthereumGenesis:").append(getEthereumGenesis()).append(",");
		b.append("EthereumDatabaseCache:").append(getEthereumDatabaseCache()).append(",");
		b.append("EthereumNetStats:").append(getEthereumNetStats()).append(",");
		b.append("WhisperEnabled:").append(getWhisperEnabled()).append(",");
		b.append("PprofAddress:").append(getPprofAddress()).append(",");
		b.append("SyncMode:").append(getSyncMode()).append(",");
		b.append("UseLightweightKDF:").append(getUseLightweightKDF()).append(",");
		return b.append("}").toString();
	}
}

